hpp-constraints: hpp::constraints::ConvexShapeContactHold Class Reference

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::constraints::ConvexShapeContactHold Class Reference
Constraints

`#include <hpp/constraints/convex-shape-contact.hh>`

Inheritance diagram for hpp::constraints::ConvexShapeContactHold:
[legend]
Collaboration diagram for hpp::constraints::ConvexShapeContactHold:
[legend]

## Public Member Functions
ConvexShapeContactPtr_t | contactConstraint () const
ConvexShapeContactComplementPtr_t | complement () const
std::pair< JointConstPtr_t, JointConstPtr_t > | dependsOnRelPoseBetween (DeviceConstPtr_t) const
Public Member Functions inherited from hpp::constraints::DifferentiableFunction
virtual | ~DifferentiableFunction ()
LiegroupElement | operator() (vectorIn_t argument) const
void | value (LiegroupElementRef result, vectorIn_t argument) const
void | jacobian (matrixOut_t jacobian, vectorIn_t argument) const
const ArrayXb & | activeParameters () const
const ArrayXb & | activeDerivativeParameters () const
size_type | inputSize () const
| Get dimension of input vector.
size_type | inputDerivativeSize () const
LiegroupSpacePtr_t | outputSpace () const
| Get output space.
size_type | outputSize () const
| Get dimension of output vector.
size_type | outputDerivativeSize () const
| Get dimension of output derivative vector.
const std::string & | name () const
| Get function name.
virtual std::ostream & | print (std::ostream &o) const
| Display object in a stream.
std::string | context () const
void | context (const std::string &c)
void | finiteDifferenceForward (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
void | finiteDifferenceCentral (matrixOut_t jacobian, vectorIn_t arg, DevicePtr_t robot=DevicePtr_t(), value_type eps=std::sqrt(Eigen::NumTraits< value_type >::epsilon())) const
bool | operator== (DifferentiableFunction const &other) const
bool | operator!= (DifferentiableFunction const &b) const

## Static Public Member Functions
static ConvexShapeContactHoldPtr_t | create (const std::string &name, DevicePtr_t robot, const JointAndShapes_t &floorSurfaces, const JointAndShapes_t &objectSurfaces)
Static Public Member Functions inherited from hpp::constraints::DifferentiableFunction
static DifferentiableFunctionPtr_t | extract (DifferentiableFunctionPtr_t original, interval_t interval)

## Protected Member Functions
| ConvexShapeContactHold (const std::string &name, DevicePtr_t robot, const JointAndShapes_t &floorSurfaces, const JointAndShapes_t &objectSurfaces)
virtual void | impl_compute (LiegroupElementRef result, vectorIn_t argument) const
| User implementation of function evaluation.
virtual void | impl_jacobian (matrixOut_t jacobian, vectorIn_t arg) const
bool | isEqual (const DifferentiableFunction &other) const
Protected Member Functions inherited from hpp::constraints::DifferentiableFunction
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, size_type sizeOutput, std::string name=std::string())
| Concrete class constructor should call this constructor.
| DifferentiableFunction (size_type sizeInput, size_type sizeInputDerivative, const LiegroupSpacePtr_t &outputSpace, std::string name=std::string())
| Concrete class constructor should call this constructor.
| DifferentiableFunction ()

## Additional Inherited Members
Protected Attributes inherited from hpp::constraints::DifferentiableFunction
size_type | inputSize_
| Dimension of input vector.
size_type | inputDerivativeSize_
| Dimension of input derivative.
LiegroupSpacePtr_t | outputSpace_
| Dimension of output vector.
ArrayXb | activeParameters_
ArrayXb | activeDerivativeParameters_

## Detailed Description

Combination of ConvexShapeContact and complement constaints

Create one instance of

- ConvexShapeContact,
- ConvexShapeContactComplement,

and concatenate their values.

## Constructor & Destructor Documentation

## ◆ ConvexShapeContactHold()

hpp::constraints::ConvexShapeContactHold::ConvexShapeContactHold | ( | const std::string & | name,
|  | DevicePtr_t | robot,
|  | const JointAndShapes_t & | floorSurfaces,
|  | const JointAndShapes_t & | objectSurfaces )
| protected

Constructor

Parameters

  constraintName | name of the ConvexShapeContact instance,
  complementName | name of the ConvexShapeContactComplement instance,
  holdName | name of this DifferentiableFunction instance
  robot | the input space of the function is the robot configuration space.

## Member Function Documentation

## ◆ complement()

ConvexShapeContactComplementPtr_t hpp::constraints::ConvexShapeContactHold::complement | ( |  | ) | const
| inline

## ◆ contactConstraint()

ConvexShapeContactPtr_t hpp::constraints::ConvexShapeContactHold::contactConstraint | ( |  | ) | const
| inline

## ◆ create()

static ConvexShapeContactHoldPtr_t hpp::constraints::ConvexShapeContactHold::create | ( | const std::string & | name,
|  | DevicePtr_t | robot,
|  | const JointAndShapes_t & | floorSurfaces,
|  | const JointAndShapes_t & | objectSurfaces )
| static

Create instance and return shared pointer

Parameters

  constraintName | name of the ConvexShapeContact instance,
  complementName | name of the ConvexShapeContactComplement instance,
  holdName | name of this DifferentiableFunction instance
  robot | the input space of the function is the robot configuration space.

## ◆ dependsOnRelPoseBetween()

std::pair< JointConstPtr_t, JointConstPtr_t > hpp::constraints::ConvexShapeContactHold::dependsOnRelPoseBetween | ( | DeviceConstPtr_t |  | ) | const
| inline virtual

Return pair of joints the relative pose between which modifies the function value if any

Currently only supports the case when all the joints for floors are the same and all the joints for objects involved are the same

Returns
  pair of joints whose relative pose determines the value of the contact function, arranged in order of increasing joint index, or a pair of empty shared pointers.

Reimplemented from hpp::constraints::DifferentiableFunction.

## ◆ impl_compute()

virtual void hpp::constraints::ConvexShapeContactHold::impl_compute | ( | LiegroupElementRef | result,
|  | vectorIn_t | argument ) const
| protected virtual

User implementation of function evaluation.

Implements hpp::constraints::DifferentiableFunction.

## ◆ impl_jacobian()

virtual void hpp::constraints::ConvexShapeContactHold::impl_jacobian | ( | matrixOut_t | jacobian,
|  | vectorIn_t | arg ) const
| protected virtual

Implements hpp::constraints::DifferentiableFunction.

## ◆ isEqual()

bool hpp::constraints::ConvexShapeContactHold::isEqual | ( | const DifferentiableFunction & | other | ) | const
| protected virtual

Reimplemented from hpp::constraints::DifferentiableFunction.

The documentation for this class was generated from the following file:

- include/hpp/constraints/convex-shape-contact.hh